package jalview.api;

import java.awt.Color;

public interface ViewStyleI
{

  void setColourAppliesToAllGroups(boolean b);

  boolean getColourAppliesToAllGroups();

  boolean getAbovePIDThreshold();

  void setIncrement(int inc);

  int getIncrement();

  boolean getConservationSelected();

  void setConservationSelected(boolean b);

  void setShowHiddenMarkers(boolean show);

  boolean getShowHiddenMarkers();

  void setScaleRightWrapped(boolean b);

  void setScaleLeftWrapped(boolean b);

  void setScaleAboveWrapped(boolean b);

  boolean getScaleLeftWrapped();

  boolean getScaleAboveWrapped();

  boolean getScaleRightWrapped();

  void setAbovePIDThreshold(boolean b);

  void setThreshold(int thresh);

  int getThreshold();

  boolean getShowJVSuffix();

  void setShowJVSuffix(boolean b);

  void setWrapAlignment(boolean state);

  void setShowText(boolean state);

  void setRenderGaps(boolean state);

  boolean getColourText();

  void setColourText(boolean state);

  void setShowBoxes(boolean state);

  boolean getWrapAlignment();

  boolean getShowText();

  int getWrappedWidth();

  void setWrappedWidth(int w);

  int getCharHeight();

  void setCharHeight(int h);

  int getCharWidth();

  void setCharWidth(int w);

  boolean getShowBoxes();

  boolean getShowUnconserved();

  void setShowUnconserved(boolean showunconserved);

  boolean isDisplayReferenceSeq();

  void setDisplayReferenceSeq(boolean displayReferenceSeq);

  boolean isColourByReferenceSeq();

  void setSeqNameItalics(boolean default1);

  void setShowSequenceFeatures(boolean b);

  boolean isShowSequenceFeatures();

  boolean isRightAlignIds();

  void setRightAlignIds(boolean rightAlignIds);

  boolean isShowAnnotation();

  void setShowAnnotation(boolean b);

  void setShowSeqFeaturesHeight(boolean selected);

  boolean isShowSequenceFeaturesHeight();

  void setColourByReferenceSeq(boolean colourByReferenceSeq);

  Color getTextColour();

  Color getTextColour2();

  int getThresholdTextColour();

  boolean isConservationColourSelected();

  boolean isRenderGaps();

  boolean isShowColourText();

  boolean isShowSeqFeaturesHeight();

  void setConservationColourSelected(boolean conservationColourSelected);

  void setShowColourText(boolean showColourText);

  void setTextColour(Color textColour);

  void setThresholdTextColour(int thresholdTextColour);

  void setTextColour2(Color textColour2);

  boolean isSeqNameItalics();

  void setUpperCasebold(boolean upperCasebold);

  boolean isUpperCasebold();
  
  boolean sameStyle(ViewStyleI them);

  void setFontName(String name);

  void setFontStyle(int style);

  void setFontSize(int size);

  int getFontStyle();

  String getFontName();

  int getFontSize();

  /**
   * @return width of Sequence and Annotation ID margin. If less than zero, then
   *         width will be autocalculated
   */
  int getIdWidth();

  /**
   * Set width if
   * 
   * @param i
   */

  void setIdWidth(int i);

  /**
   * centre columnar annotation labels in displayed alignment annotation
   */
  boolean isCentreColumnLabels();

  /**
   * centre columnar annotation labels in displayed alignment annotation
   */
  void setCentreColumnLabels(boolean centreColumnLabels);

  /**
   * enable or disable the display of Database Cross References in the sequence
   * ID tooltip
   */
  void setShowDBRefs(boolean showdbrefs);

  /**
   * 
   * @return true if Database References are to be displayed on tooltips.
   */
  boolean isShowDBRefs();

  /**
   * 
   * @return true if Non-positional features are to be displayed on tooltips.
   */
  boolean isShowNPFeats();

  /**
   * enable or disable the display of Non-Positional sequence features in the
   * sequence ID tooltip
   * 
   * @param show
   */
  void setShowNPFeats(boolean shownpfeats);

}
